#ifndef CAMWIDGET_HPP
#define CAMWIDGET_HPP

#include <qimage.h>
#include <qwidget.h>

#include "pwc-ioctl.h"

class CCamWidget: public QWidget
{
   Q_OBJECT
public:
private:
   pwc_coord m_ViewSize, m_RealSize; // desired and real webcam image size
   pwc_coord m_Offset; // offset (calculated from the two parameters above)
   QString m_DeviceName;
   int m_Frames;
   int m_FD;
   bool m_UseRaw;
   bool m_Bayer;

   void *m_pPWCXBuffer;
   int m_Bandlength;
   int m_Type;

   QSize m_ImageSize; // visible size on screen (including YUV stuff)
   QImage m_FullImage;
   void *m_pInputBuffer;
   int m_InputLen;
   void *m_pImageBuffer;
   int m_ImageLen;

private slots:
   void TimeOut();

protected:
   void paintEvent(QPaintEvent *);

public:
   CCamWidget(QWidget *parent = 0, const char *name = 0);
   ~CCamWidget();

   QSize sizeHint() const;

   void SetDevice(const QString &);
   void SetRaw(bool);
   void SetBayer(bool);
   bool Start();
};

#endif
