#include <qapplication.h>
#include <qmainwindow.h>

#include "CamWidget.h"


int main(int argc, char *argv[])
{
   QApplication App(argc, argv);
   QMainWindow MainWindow;
   CCamWidget *pWidget;
   int i;

   MainWindow.setCaption("PWC tester");
   pWidget = new CCamWidget(&MainWindow, "camera");

   /* Parse command line */
   for (i = 1; i < App.argc(); i++)
   {
      if (App.argv()[i][0] == '-') /* option */
      {
        switch(App.argv()[i][1])
        {
          case 'r': // raw mode
            pWidget->SetRaw(true);
            break;
            
          case 'B': // Bayer 
            pWidget->SetBayer(true);
            break;
            
          default:
            qWarning("Unknown option '%c'.", App.argv()[i][1]);
            break;
        }
      }
      else
      {
        pWidget->SetDevice(App.argv()[i]);
      }
   }

   if (pWidget->Start())
   {
     MainWindow.setCentralWidget(pWidget);
     App.setMainWidget(&MainWindow);
     MainWindow.show();
     return App.exec();
   }
   return 0;
}
